[comment]: # (#################################################################)
[comment]: # (Copyright 2017-2021, Lawrence Livermore National Security, LLC)
[comment]: # (and Axom Project Developers. See the top-level LICENSE file)
[comment]: # (for details.)
[comment]: #
[comment]: # (# SPDX-License-Identifier: BSD-3-Clause)
[comment]: # (#################################################################)


# <img src="/share/axom/logo/axom_logo.png?raw=true" width="250" valign="middle" alt="Axom"/>

[![Azure Pipelines Build Status](https://dev.azure.com/axom/axom/_apis/build/status/LLNL.axom?branchName=develop)](https://dev.azure.com/axom/axom/_build/latest?definitionId=1&branchName=develop)
[![Documentation Status](https://readthedocs.org/projects/axom/badge/?version=develop)](https://axom.readthedocs.io/en/develop/?badge=develop)
[![License](https://img.shields.io/badge/License-BSD%203--Clause-blue.svg)](https://github.com/LLNL/axom/blob/develop/LICENSE)
[![GitHub release](https://img.shields.io/github/release/LLNL/axom.svg)](https://github.com/LLNL/axom/releases/latest)

Axom provides robust, flexible software infrastructure for the development of multi-physics applications and computational tools.

Documentation
-------------

Latest docs on Develop branch: https://axom.readthedocs.io

To access docs for other versions: https://readthedocs.org/projects/axom/

Getting Involved
----------------

Axom is an open-source project and we welcome contributions from the community.

Mailing List
------------

The project maintains two email lists: 

  * 'axom-users@llnl.gov' is how Axom users can contact developers for questions, report issues, etc.
  * 'axom-dev@llnl.gov' is for communication among team members.

Contributions
-------------

We welcome all kinds of contributions: new features, bug fixes, documentation edits.

To contribute, make a [pull request](https://github.com/llnl/axom/compare), with `develop`
as the destination branch. We use CI testing and your branch must pass these tests before
being merged.

For more information, see the [contributing guide](https://github.com/llnl/axom/blob/develop/CONTRIBUTING.md).

Authors
-------

Thanks to all of Axom's
[contributors](https://github.com/llnl/axom/graphs/contributors).

License
-------

Copyright (c) 2017-2021, Lawrence Livermore National Security, LLC. 
Produced at the Lawrence Livermore National Laboratory.

Copyrights and patents in the Axom project are retained by contributors.
No copyright assignment is required to contribute to Axom.

See [LICENSE](./LICENSE) for details.

Unlimited Open Source - BSD 3-clause Distribution
`LLNL-CODE-741217` `OCEC-17-187`

SPDX usage
------------

Individual files contain SPDX tags instead of the full license text.
This enables machine processing of license information based on the SPDX
License Identifiers that are available here: https://spdx.org/licenses/

Files that are licensed as BSD 3-Clause contain the following
text in the license header:

    SPDX-License-Identifier: (BSD-3-Clause)

External Packages
-----------------

Axom bundles some of its external dependencies in its repository.  These
packages are covered by various permissive licenses.  A summary listing
follows.  See the license included with each package for full details.


[//]: # (Note: The spaces at the end of each line below add line breaks)

PackageName: BLT  
PackageHomePage: https://github.com/LLNL/blt  
PackageLicenseDeclared: BSD-3-Clause  

PackageName: CLI11  
PackageHomePage: https://github.com/CLIUtils/CLI11  
PackageLicenseDeclared: BSD-3-Clause  

PackageName: fmt  
PackageHomePage: https://github.com/fmtlib/fmt  
PackageLicenseDeclared: MIT License  

PackageName: sol  
PackageHomePage: https://github.com/ThePhD/sol2  
PackageLicenseDeclared: MIT License  

PackageName: sparsehash  
PackageHomePage: https://github.com/sparsehash/sparsehash  
PackageLicenseDeclared: BSD-3-Clause  

PackageName: uberenv  
PackageHomePage: https://github.com/LLNL/uberenv  
PackageLicenseDeclared: BSD-3-Clause  

